
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, 2012 and Azure
-- --------------------------------------------------
-- Date Created: 09/21/2022 19:18:18
-- Generated from EDMX file: C:\Users\Imagara\source\repos\RaspisKusach\RaspisKusach\EDM.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [RouteScheduleDataBase];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_Carriages_Trains]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Carriages] DROP CONSTRAINT [FK_Carriages_Trains];
GO
IF OBJECT_ID(N'[dbo].[FK_RoutesStations_Routes]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[RoutesStations] DROP CONSTRAINT [FK_RoutesStations_Routes];
GO
IF OBJECT_ID(N'[dbo].[FK_RoutesStations_Stations]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[RoutesStations] DROP CONSTRAINT [FK_RoutesStations_Stations];
GO
IF OBJECT_ID(N'[dbo].[FK_Tickets_Carriages]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Tickets] DROP CONSTRAINT [FK_Tickets_Carriages];
GO
IF OBJECT_ID(N'[dbo].[FK_Tickets_Trips]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Tickets] DROP CONSTRAINT [FK_Tickets_Trips];
GO
IF OBJECT_ID(N'[dbo].[FK_Tickets_Users]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Tickets] DROP CONSTRAINT [FK_Tickets_Users];
GO
IF OBJECT_ID(N'[dbo].[FK_Trips_Routes]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Trips] DROP CONSTRAINT [FK_Trips_Routes];
GO
IF OBJECT_ID(N'[dbo].[FK_Trips_Trains]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Trips] DROP CONSTRAINT [FK_Trips_Trains];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Carriages]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Carriages];
GO
IF OBJECT_ID(N'[dbo].[Routes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Routes];
GO
IF OBJECT_ID(N'[dbo].[RoutesStations]', 'U') IS NOT NULL
    DROP TABLE [dbo].[RoutesStations];
GO
IF OBJECT_ID(N'[dbo].[Stations]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Stations];
GO
IF OBJECT_ID(N'[dbo].[sysdiagrams]', 'U') IS NOT NULL
    DROP TABLE [dbo].[sysdiagrams];
GO
IF OBJECT_ID(N'[dbo].[Tickets]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Tickets];
GO
IF OBJECT_ID(N'[dbo].[Trains]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Trains];
GO
IF OBJECT_ID(N'[dbo].[Trips]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Trips];
GO
IF OBJECT_ID(N'[dbo].[Users]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Users];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Carriages'
CREATE TABLE [dbo].[Carriages] (
    [IdCarriage] int  NOT NULL,
    [IdTrain] int  NOT NULL,
    [Places] int  NOT NULL,
    [Category] nvarchar(50)  NOT NULL
);
GO

-- Creating table 'Routes'
CREATE TABLE [dbo].[Routes] (
    [IdRoute] int  NOT NULL,
    [Name] nvarchar(50)  NULL
);
GO

-- Creating table 'RoutesStations'
CREATE TABLE [dbo].[RoutesStations] (
    [IdRouteStation] int  NOT NULL,
    [IdRoute] int  NOT NULL,
    [IdStation] int  NOT NULL,
    [StopTime] time  NOT NULL,
    [TravelTime] time  NOT NULL
);
GO

-- Creating table 'Stations'
CREATE TABLE [dbo].[Stations] (
    [IdStation] int  NOT NULL,
    [Name] nvarchar(50)  NOT NULL,
    [Location] nvarchar(50)  NOT NULL
);
GO

-- Creating table 'sysdiagrams'
CREATE TABLE [dbo].[sysdiagrams] (
    [name] nvarchar(128)  NOT NULL,
    [principal_id] int  NOT NULL,
    [diagram_id] int IDENTITY(1,1) NOT NULL,
    [version] int  NULL,
    [definition] varbinary(max)  NULL
);
GO

-- Creating table 'Tickets'
CREATE TABLE [dbo].[Tickets] (
    [IdTicket] int  NOT NULL,
    [IdUser] int  NOT NULL,
    [IdTrip] int  NOT NULL,
    [IdCarriage] int  NOT NULL,
    [PlaceNumber] int  NOT NULL,
    [BuyDate] datetime  NOT NULL
);
GO

-- Creating table 'Trains'
CREATE TABLE [dbo].[Trains] (
    [IdTrain] int  NOT NULL,
    [Name] nvarchar(50)  NOT NULL,
    [Category] nvarchar(50)  NOT NULL
);
GO

-- Creating table 'Trips'
CREATE TABLE [dbo].[Trips] (
    [IdTrip] int  NOT NULL,
    [IdTrain] int  NOT NULL,
    [IdRoute] int  NOT NULL,
    [TripStartDate] datetime  NOT NULL
);
GO

-- Creating table 'Users'
CREATE TABLE [dbo].[Users] (
    [IdUser] int  NOT NULL,
    [Login] nvarchar(50)  NOT NULL,
    [Password] nvarchar(50)  NOT NULL,
    [Passport] nvarchar(10)  NOT NULL,
    [Surname] nvarchar(50)  NOT NULL,
    [Name] nvarchar(50)  NOT NULL,
    [Patronymic] nvarchar(50)  NOT NULL,
    [Permissions] int  NOT NULL,
    [Email] nvarchar(50)  NOT NULL,
    [PhoneNum] nvarchar(11)  NOT NULL,
    [Image] varbinary(max)  NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [IdCarriage] in table 'Carriages'
ALTER TABLE [dbo].[Carriages]
ADD CONSTRAINT [PK_Carriages]
    PRIMARY KEY CLUSTERED ([IdCarriage] ASC);
GO

-- Creating primary key on [IdRoute] in table 'Routes'
ALTER TABLE [dbo].[Routes]
ADD CONSTRAINT [PK_Routes]
    PRIMARY KEY CLUSTERED ([IdRoute] ASC);
GO

-- Creating primary key on [IdRouteStation] in table 'RoutesStations'
ALTER TABLE [dbo].[RoutesStations]
ADD CONSTRAINT [PK_RoutesStations]
    PRIMARY KEY CLUSTERED ([IdRouteStation] ASC);
GO

-- Creating primary key on [IdStation] in table 'Stations'
ALTER TABLE [dbo].[Stations]
ADD CONSTRAINT [PK_Stations]
    PRIMARY KEY CLUSTERED ([IdStation] ASC);
GO

-- Creating primary key on [diagram_id] in table 'sysdiagrams'
ALTER TABLE [dbo].[sysdiagrams]
ADD CONSTRAINT [PK_sysdiagrams]
    PRIMARY KEY CLUSTERED ([diagram_id] ASC);
GO

-- Creating primary key on [IdTicket] in table 'Tickets'
ALTER TABLE [dbo].[Tickets]
ADD CONSTRAINT [PK_Tickets]
    PRIMARY KEY CLUSTERED ([IdTicket] ASC);
GO

-- Creating primary key on [IdTrain] in table 'Trains'
ALTER TABLE [dbo].[Trains]
ADD CONSTRAINT [PK_Trains]
    PRIMARY KEY CLUSTERED ([IdTrain] ASC);
GO

-- Creating primary key on [IdTrip] in table 'Trips'
ALTER TABLE [dbo].[Trips]
ADD CONSTRAINT [PK_Trips]
    PRIMARY KEY CLUSTERED ([IdTrip] ASC);
GO

-- Creating primary key on [IdUser] in table 'Users'
ALTER TABLE [dbo].[Users]
ADD CONSTRAINT [PK_Users]
    PRIMARY KEY CLUSTERED ([IdUser] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [IdTrain] in table 'Carriages'
ALTER TABLE [dbo].[Carriages]
ADD CONSTRAINT [FK_Carriages_Trains]
    FOREIGN KEY ([IdTrain])
    REFERENCES [dbo].[Trains]
        ([IdTrain])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating non-clustered index for FOREIGN KEY 'FK_Carriages_Trains'
CREATE INDEX [IX_FK_Carriages_Trains]
ON [dbo].[Carriages]
    ([IdTrain]);
GO

-- Creating foreign key on [IdCarriage] in table 'Tickets'
ALTER TABLE [dbo].[Tickets]
ADD CONSTRAINT [FK_Tickets_Carriages]
    FOREIGN KEY ([IdCarriage])
    REFERENCES [dbo].[Carriages]
        ([IdCarriage])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating non-clustered index for FOREIGN KEY 'FK_Tickets_Carriages'
CREATE INDEX [IX_FK_Tickets_Carriages]
ON [dbo].[Tickets]
    ([IdCarriage]);
GO

-- Creating foreign key on [IdRoute] in table 'RoutesStations'
ALTER TABLE [dbo].[RoutesStations]
ADD CONSTRAINT [FK_RoutesStations_Routes]
    FOREIGN KEY ([IdRoute])
    REFERENCES [dbo].[Routes]
        ([IdRoute])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating non-clustered index for FOREIGN KEY 'FK_RoutesStations_Routes'
CREATE INDEX [IX_FK_RoutesStations_Routes]
ON [dbo].[RoutesStations]
    ([IdRoute]);
GO

-- Creating foreign key on [IdRoute] in table 'Trips'
ALTER TABLE [dbo].[Trips]
ADD CONSTRAINT [FK_Trips_Routes]
    FOREIGN KEY ([IdRoute])
    REFERENCES [dbo].[Routes]
        ([IdRoute])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating non-clustered index for FOREIGN KEY 'FK_Trips_Routes'
CREATE INDEX [IX_FK_Trips_Routes]
ON [dbo].[Trips]
    ([IdRoute]);
GO

-- Creating foreign key on [IdStation] in table 'RoutesStations'
ALTER TABLE [dbo].[RoutesStations]
ADD CONSTRAINT [FK_RoutesStations_Stations]
    FOREIGN KEY ([IdStation])
    REFERENCES [dbo].[Stations]
        ([IdStation])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating non-clustered index for FOREIGN KEY 'FK_RoutesStations_Stations'
CREATE INDEX [IX_FK_RoutesStations_Stations]
ON [dbo].[RoutesStations]
    ([IdStation]);
GO

-- Creating foreign key on [IdTrip] in table 'Tickets'
ALTER TABLE [dbo].[Tickets]
ADD CONSTRAINT [FK_Tickets_Trips]
    FOREIGN KEY ([IdTrip])
    REFERENCES [dbo].[Trips]
        ([IdTrip])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating non-clustered index for FOREIGN KEY 'FK_Tickets_Trips'
CREATE INDEX [IX_FK_Tickets_Trips]
ON [dbo].[Tickets]
    ([IdTrip]);
GO

-- Creating foreign key on [IdUser] in table 'Tickets'
ALTER TABLE [dbo].[Tickets]
ADD CONSTRAINT [FK_Tickets_Users]
    FOREIGN KEY ([IdUser])
    REFERENCES [dbo].[Users]
        ([IdUser])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating non-clustered index for FOREIGN KEY 'FK_Tickets_Users'
CREATE INDEX [IX_FK_Tickets_Users]
ON [dbo].[Tickets]
    ([IdUser]);
GO

-- Creating foreign key on [IdTrain] in table 'Trips'
ALTER TABLE [dbo].[Trips]
ADD CONSTRAINT [FK_Trips_Trains]
    FOREIGN KEY ([IdTrain])
    REFERENCES [dbo].[Trains]
        ([IdTrain])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating non-clustered index for FOREIGN KEY 'FK_Trips_Trains'
CREATE INDEX [IX_FK_Trips_Trains]
ON [dbo].[Trips]
    ([IdTrain]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------